describe :hooks do

  it 'calls before and after hooks' do
    called = 0
    spec rand do
      before {called += 1}
      after {called += 1}
      test(:x) {}
      run(:x)
    end
    assert_equal 2, called
  end

  it 'calls around hooks' do
    called = false
    spec rand do
      around {|test| test.call}
      test(:x) {called = true}
      run(:x)
    end
    assert_equal true, called
  end

  it 'inherits hooks' do
    spec_hooks, context_hooks = nil
    spec rand do
      before {}
      context rand do
        context_hooks = hooks
      end
      spec_hooks = hooks
    end
    assert_equal context_hooks, spec_hooks
  end
end
