describe :raise do

  it 'should pass if any exception raised' do
    this = self
    spec rand do
      test(:test) {assert {x}.raise}
      this.assert_equal :__tokyo_passed__, run(:test)
    end
  end

  it 'should fail if nothing raised' do
    this = self
    spec rand do
      test(:test) {assert {}.raise}
      this.assert_equal Tokyo::GenericFailure, run(:test).class
    end
  end

  it 'should pass if type matching' do
    this = self
    spec rand do
      test(:test) {assert {x}.raise(NameError)}
      this.assert_equal :__tokyo_passed__, run(:test)
    end
  end

  it 'should fail if wrong exception raised' do
    this = self
    spec rand do
      test(:test) {assert {}.raise(ArgumentError)}
      this.assert_equal Tokyo::GenericFailure, run(:test).class
    end
  end

  it 'should pass if both type and message matches' do
    this = self
    spec rand do
      test(:test) {assert {x}.raise NameError, /undefined local variable or method/}
      this.assert_equal :__tokyo_passed__, run(:test)
    end
  end

  it 'should fail if message does not match' do
    this = self
    spec rand do
      test(:test) {assert {x}.raise(NameError, /blah/)}
      this.assert_equal Tokyo::GenericFailure, run(:test).class
    end
  end

  it 'should pass if given block validates the raised error' do
    this = self
    spec rand do
      test(:test) {assert {x}.raise {|e| e.class == NameError && e.message =~ /undefined local variable or method/}}
      this.assert_equal :__tokyo_passed__, run(:test)
    end
  end

  it 'should fail if given block invalidates raised error' do
    this = self
    spec rand do
      test(:test) {assert {x}.raise {false}}
      this.assert_equal Tokyo::GenericFailure, run(:test).class
    end
  end
end
