describe :receive_and_return do

  it 'should pass when expected message returns expected value' do
    this = self
    spec rand do
      test :test do
        expect(x = 'x').to_receive(:+).with('y').and_return('xy')
        x + 'y'
      end
      this.assert_equal :__tokyo_passed__, run(:test)
    end
  end

  it 'should fail when expected message returns wrong value' do
    this = self
    spec rand do
      test :test do
        expect(x = 'x').to_receive(:to_s).and_return(:y)
        x.to_s
      end
      this.assert_match /Looks like :to_s message never returned expected value/, run(:test).reason*' '
    end
  end

  it 'should pass when block validates returned value' do
    this = self
    spec rand do
      test :test do
        expect(x = 'x').to_receive(:+).with('y').and_return {|v| v == 'xy'}
        x + 'y'
      end
      this.assert_equal :__tokyo_passed__, run(:test)
    end
  end

  it 'should fail when block does not validate returned value' do
    this = self
    spec rand do
      test :test do
        expect(x = 'x').to_receive(:+).with('y').and_return {false}
        x + 'y'
      end
      this.assert_match /Looks like :\+ message never returned expected value/, run(:test).reason*' '
    end
  end
end
