describe :receive do

  it 'should pass when a message expected and received' do
    this = self
    spec rand do
      test :test do
        expect(x = 'x').to_receive(:class)
        x.class
      end
      this.assert_equal :__tokyo_passed__, run(:test)
    end
  end

  it 'should fail when a expected message not received' do
    this = self
    spec rand do
      test :test do
        expect(x = 'x').to_receive(:class)
      end
      this.assert_equal Tokyo::GenericFailure, run(:test).class
    end
  end

  it 'should pass when no message expected and no message received' do
    this = self
    spec rand do
      test :test do
        fail_if(x = 'x').receive(:class)
      end
      this.assert_equal :__tokyo_passed__, run(:test)
    end
  end

  it 'should fail when unexpected message received' do
    this = self
    spec rand do
      test :test do
        fail_if(x = 'x').receive(:class)
        x.class
      end
      this.assert_equal Tokyo::GenericFailure, run(:test).class
    end
  end

  describe 'missing methods' do

    it 'should call method_missing if defined' do
      this = self
      x = Class.new {def self.method_missing(m); 'x' + m.to_s; end}
      spec rand do
        test :test do
          assert(x).receive(:y)
          x.y
        end
        this.assert_equal 'xy', x.y
        this.assert_equal :__tokyo_passed__, run(:test)
      end
    end

    it 'should raise NoMethodError if no method_missing defined' do
      this = self
      spec rand do
        test :test do
          assert(x = 'x').receive(:y).and_raise(NoMethodError)
          x.y
        end
        this.assert_equal :__tokyo_passed__, run(:test)
      end
    end
  end
end
