describe :receive_with do

  it 'should pass when called with correct arguments' do
    this = self
    spec rand do
      test :test do
        expect(x = 'x').to_receive(:+).with('y')
        x + 'y'
      end
      this.assert_equal :__tokyo_passed__, run(:test)
    end
  end

  it 'should fail when called without arguments' do
    this = self
    spec rand do
      test :test do
        expect(x = []).to_receive(:join).with('')
        x.join
      end
      this.assert_match /Looks like :join message never was called with expected arguments/, run(:test).reason*' '
    end
  end

  it 'should fail when called with wrong arguments' do
    this = self
    spec rand do
      test :test do
        expect(x = []).to_receive(:join).with('')
        x.join('/')
      end
      this.assert_match /Looks like :join message never was called with expected arguments/, run(:test).reason*' '
    end
  end

  it 'should pass when block validates arguments' do
    this = self
    spec rand do
      test :test do
        expect(x = 'x').to_receive(:+).with {|a| a == ['y']}
        x + 'y'
      end
      this.assert_equal :__tokyo_passed__, run(:test)
    end
  end

  it 'should fail when block does not validate arguments' do
    this = self
    spec rand do
      test :test do
        expect(x = 'x').to_receive(:+).with {false}
        x + 'y'
      end
      this.assert_match /Looks like :\+ message never was called with expected arguments/, run(:test).reason*' '
    end
  end
end
