describe :skip do

  it 'should skip inside spec' do
    r, w = IO.pipe
    fork do
      r.close
      s = Tokyo.define_spec :skip_spec, proc {
        test(:a) {}
        skip
        test(:b) {}
      }
      w.print({skips: Tokyo.skips.size, tests: s.tests.size}.to_json)
    end
    w.close
    data = JSON.parse(r.read)
    assert_equal 1, data['skips']
    assert_equal 1, data['tests']
  end

  it 'should skip inside test' do
    r, w = IO.pipe
    fork do
      r.close
      Tokyo.define_and_register_a_spec :skip_test, proc {
        test :x do
          skip
          w.print 'bad'
        end
      }
      Tokyo.run
    end
    w.close
    assert_equal '', r.read
  end
end
