describe :throw do

  it 'should pass when any symbol expected and something thrown' do
    this = self
    spec rand do
      test(:test) {assert {throw :x}.throw}
      this.assert_equal :__tokyo_passed__, run(:test)
    end
  end

  it 'should pass when specific symbol expected and thrown' do
    this = self
    spec rand do
      test(:test) {assert {throw :x}.throw(:x)}
      this.assert_equal :__tokyo_passed__, run(:test)
    end
  end

  it 'should fail when any throw expected but nothing thrown' do
    this = self
    spec rand do
      test(:test) {assert {}.throw}
      this.assert_equal Tokyo::GenericFailure, run(:test).class
    end
  end

  it 'should fail when specific symbol expected but nothing thrown' do
    this = self
    spec rand do
      test(:test) {assert {}.throw(:x)}
      this.assert_equal Tokyo::GenericFailure, run(:test).class
    end
  end

  it 'should fail when wrong symbol thrown' do
    this = self
    spec rand do
      test(:test) {assert {throw :y}.throw(:x)}
      this.assert_equal Tokyo::GenericFailure, run(:test).class
    end
  end

  it 'should pass when given block validates thrown symbol' do
    this = self
    spec rand do
      test(:test) {assert {throw :x}.throw {|s| s == :x}}
      this.assert_equal :__tokyo_passed__, run(:test)
    end
  end

  it 'should fail when given block invalidates thrown symbol' do
    this = self
    spec rand do
      test(:test) {assert {}.throw {false}}
      this.assert_equal Tokyo::GenericFailure, run(:test).class
    end
  end
end
